
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Game_modesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_modes = await db.game_modes.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        mode_key: data.mode_key
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        is_official: data.is_official
        ||
        false
        
            ,
            
        is_enabled: data.is_enabled
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.game_modes.getTableName(),
                belongsToColumn: 'mode_images',
                belongsToId: game_modes.id,
            },
            data.mode_images,
            options,
        );
        

        return game_modes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const game_modesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                mode_key: item.mode_key
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                is_official: item.is_official
            ||
            false
        
            ,
            
                is_enabled: item.is_enabled
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const game_modes = await db.game_modes.bulkCreate(game_modesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < game_modes.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.game_modes.getTableName(),
                    belongsToColumn: 'mode_images',
                    belongsToId: game_modes[i].id,
                },
                data[i].mode_images,
                options,
            );
        }
        

        return game_modes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const game_modes = await db.game_modes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.mode_key !== undefined) updatePayload.mode_key = data.mode_key;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.is_official !== undefined) updatePayload.is_official = data.is_official;
        
        
        if (data.is_enabled !== undefined) updatePayload.is_enabled = data.is_enabled;
        
        
        updatePayload.updatedById = currentUser.id;

        await game_modes.update(updatePayload, {transaction});

        
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.game_modes.getTableName(),
                belongsToColumn: 'mode_images',
                belongsToId: game_modes.id,
            },
            data.mode_images,
            options,
        );
        

        return game_modes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_modes = await db.game_modes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of game_modes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of game_modes) {
                await record.destroy({transaction});
            }
        });


        return game_modes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const game_modes = await db.game_modes.findByPk(id, options);

        await game_modes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await game_modes.destroy({
            transaction
        });

        return game_modes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const game_modes = await db.game_modes.findOne(
            { where },
            { transaction },
        );

        if (!game_modes) {
            return game_modes;
        }

        const output = game_modes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.matches_mode = await game_modes.getMatches_mode({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.leaderboard_entries_mode = await game_modes.getLeaderboard_entries_mode({
            transaction
        });
        
        
        
        output.mode_images = await game_modes.getMode_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



      {
        model: db.file,
        as: 'mode_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'game_modes',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'game_modes',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.mode_key) {
                where = {
                    ...where,
                mode_key: filter.mode_key,
            };
            }
            
            if (filter.is_official) {
                where = {
                    ...where,
                is_official: filter.is_official,
            };
            }
            
            if (filter.is_enabled) {
                where = {
                    ...where,
                is_enabled: filter.is_enabled,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.game_modes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'game_modes',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.game_modes.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

